PGOBLIN_BANG(-f)
--# Copyright (C) @BABOLO  2008 http://www.babolo.ru/
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: CIPA_5.m4,v 1.1 2008/01/22 08:11:51 babolo Exp $

GETARG
#echo 4
0	exchange	\N
1	distribution	\N
#copyin 004
COPY type FROM stdin;
#perform
SET_NOTNULL(type, ntype)
ALTER TABLE ONLY type     ADD PRIMARY KEY(type);
CREATE UNIQUE INDEX type_idx     ON type(ntype);

SET_NOTNULL(ftp, nftp, path, type, ugrp, agrp, suid)
ALTER TABLE ONLY ftp      ADD PRIMARY KEY(ftp);
ALTER TABLE ONLY ftp      ADD FOREIGN KEY(type)         REFERENCES type;
CREATE UNIQUE INDEX ftp_idx      ON ftp(nftp);
#select 8
SELECT 'CREATE SEQUENCE ftpn MINVALUE 0 START '
     , COALESCE((SELECT MAX(ftp) FROM ftp) + 1, 0)
#perform 08
#perform
ALTER TABLE ONLY ftp      ALTER ftp     SET DEFAULT nextval('ftpn');
CREATE OR REPLACE RULE "cipa in" AS ON INSERT TO ftp DO CONFG_PLAN(NEW);
CREATE OR REPLACE RULE "cipa up" AS ON UPDATE TO ftp DO(CONFG_PLAN(NEW); CONFG_PLAN(OLD));
CREATE OR REPLACE RULE "cipa rm" AS ON DELETE TO ftp DO CONFG_PLAN(OLD);

SET_NOTNULL(grp, grp)
ALTER TABLE ONLY grp      ADD PRIMARY KEY(ftp, ngrp);
CREATE        INDEX grp_pdx      ON grp(grp);
#select 6
SELECT 'CREATE SEQUENCE grpn MINVALUE 1000 START '
     , max( COALESCE( (SELECT MAX(grp)
                        FROM (SELECT MAX(grp) AS grp FROM grp
                             UNION
                              SELECT MAX(ugrp) AS uid FROM ftp
                             UNION
                              SELECT MAX(agrp) AS uid FROM ftp
                             )m
                      ) + 1
                    , 1000
                    )
          , 1000
          )
#perform 06
#perform
ALTER TABLE ONLY grp      ALTER grp     SET DEFAULT nextval('grpn');
ALTER TABLE ONLY grp      ADD FOREIGN KEY(ftp)          REFERENCES ftp;
ALTER TABLE ONLY grp      ALTER gena    SET DEFAULT TRUE;
CREATE OR REPLACE RULE "cipa in" AS ON INSERT TO grp DO CONFG_PLAN(NEW);
CREATE OR REPLACE RULE "cipa up" AS ON UPDATE TO grp DO(CONFG_PLAN(NEW); CONFG_PLAN(OLD));
CREATE OR REPLACE RULE "cipa rm" AS ON DELETE TO grp DO CONFG_PLAN(OLD);

ALTER TABLE ONLY ftp      ALTER ugrp    SET DEFAULT nextval('grpn');
ALTER TABLE ONLY ftp      ALTER agrp    SET DEFAULT nextval('grpn');

SET_NOTNULL(admin, admin, apass)
ALTER TABLE ONLY admin    ADD PRIMARY KEY(admin);
CREATE UNIQUE INDEX admin_pdx    ON admin(nadmin);
ALTER TABLE ONLY admin    ALTER ftplist SET DEFAULT ''::varbit;
ALTER TABLE ONLY admin    ALTER aena    SET DEFAULT TRUE;

SET_NOTNULL(client, cpass, client, super)
ALTER TABLE ONLY client   ADD PRIMARY KEY(ftp, nclient);
ALTER TABLE ONLY client   ALTER super   SET DEFAULT FALSE;
ALTER TABLE ONLY client   ADD FOREIGN KEY(ftp)          REFERENCES ftp;
ALTER TABLE ONLY client   ALTER cena    SET DEFAULT TRUE;

#select 7
SELECT 'CREATE SEQUENCE uidn MINVALUE 1000 START '
     , max( COALESCE( (SELECT MAX(uid)
                        FROM (SELECT MAX(admin) AS uid FROM admin
                             UNION
                              SELECT MAX(client) AS uid FROM client
                             UNION
                              SELECT MAX(suid) AS uid FROM ftp
                             )m
                      ) + 1
                    , 1000
                    )
          , 1000
          )
#perform 07
#perform
ALTER TABLE ONLY admin    ALTER admin   SET DEFAULT nextval('uidn');
ALTER TABLE ONLY client   ALTER client  SET DEFAULT nextval('uidn');
ALTER TABLE ONLY ftp      ALTER suid    SET DEFAULT nextval('uidn');
CREATE OR REPLACE RULE "cipa in" AS ON INSERT TO client DO CONFG_PLAN(NEW);
CREATE OR REPLACE RULE "cipa up" AS ON UPDATE TO client DO(CONFG_PLAN(NEW); CONFG_PLAN(OLD));
CREATE OR REPLACE RULE "cipa rm" AS ON DELETE TO client DO CONFG_PLAN(OLD);

ALTER TABLE ONLY cgroup   ADD PRIMARY KEY(ftp, nclient, ngrp);
ALTER TABLE ONLY cgroup   ADD FOREIGN KEY(ftp, nclient) REFERENCES client;
ALTER TABLE ONLY cgroup   ADD FOREIGN KEY(ftp, ngrp)    REFERENCES grp;
CREATE OR REPLACE RULE "cipa in" AS ON INSERT TO cgroup DO CONFG_PLAN(NEW);
CREATE OR REPLACE RULE "cipa up" AS ON UPDATE TO cgroup DO(CONFG_PLAN(NEW); CONFG_PLAN(OLD));
CREATE OR REPLACE RULE "cipa rm" AS ON DELETE TO cgroup DO CONFG_PLAN(OLD);

CREATE OR REPLACE FUNCTION check_admin(name, text, inet, text, text, text) RETURNS int4
 AS ' SELECT admin FROM admin WHERE nadmin = $1 AND apass = crypt($2, apass) AND aena'
 LANGUAGE SQL STABLE
;
COMMENT ON FUNCTION check_admin(name, text, inet, text, text, text) IS '  mod_auth_pg';

#perform
CREATE OR REPLACE FUNCTION delete_alog(regclass, oid, tid, varbit, int8, name) RETURNS bool
 AS 'BEGIN
         DELETE FROM "cipa log"
          WHERE (log, toid, whom) = ($5, $1, $6)
            AND COALESCE( (roid, coid) = ($2, $3)
                        , roid IS NULL AND coid IS NULL AND $2 IS NULL AND $3 IS NULL
                        )
            AND COALESCE( boolor(field /| $4)
                        , field IS NULL OR $4 IS NULL
                        )
         ;
         RETURN FOUND;
     END
    '
 LANGUAGE PLPGSQL
;
COMMENT ON FUNCTION delete_alog(regclass, oid, tid, varbit, int8, name)
 IS '  '
;
#perform
CREATE OR REPLACE FUNCTION delete_falog(regclass, oid, tid, varbit) RETURNS bool
 AS 'BEGIN
         DELETE FROM "cipa log"
          WHERE toid = $1
            AND COALESCE( (roid, coid) = ($2, $3)
                        , roid IS NULL AND coid IS NULL AND $2 IS NULL AND $3 IS NULL
                        )
            AND COALESCE( boolor(field /| $4)
                        , field IS NULL OR $4 IS NULL
                        )
         ;
         RETURN TRUE;
     END
    '
 LANGUAGE PLPGSQL
;
COMMENT ON FUNCTION delete_falog(regclass, oid, tid, varbit) IS '  ';

#perform
CREATE OR REPLACE FUNCTION get_alog(regclass, oid, tid, varbit, int4, text, name) RETURNS int8
 AS 'DECLARE i int4;
     BEGIN
         INSERT INTO "cipa log"(toid, roid, coid, field, link, mess, whom)
          SELECT $1, $2, $3, $4, $5, $6, $7
           WHERE delete_falog($1, $2, $3, $4)
         ;
         GET DIAGNOSTICS i := ROW_COUNT;

         RETURN CASE WHEN i = 1 THEN currval(''cipa&log&seq'') END;
     END
    '
 LANGUAGE PLPGSQL
;
COMMENT ON FUNCTION get_alog(regclass, oid, tid, varbit, int4, text, name)
 IS '     '
;
#perform
CREATE OR REPLACE FUNCTION usein_alog(int8, regclass, name) RETURNS bool
 AS 'SELECT (SELECT COUNT(*) FROM "cipa log"
              WHERE (log, toid, whom) = ($1, $2, $3)
                AND roid IS NULL
                AND coid IS NULL
                AND field IS NULL
            ) = 1
    '
 LANGUAGE SQL STABLE STRICT
;
COMMENT ON FUNCTION usein_alog(int8, regclass, name) IS '    INSERT';

CREATE OR REPLACE FUNCTION userm_alog(int8, regclass, oid, tid, name) RETURNS bool
 AS 'SELECT (SELECT COUNT(*) FROM "cipa log"
              WHERE (log, toid, roid, coid, whom) = ($1, $2, $3, $4, $5)
                AND field IS NULL
            ) = 1
    '
 LANGUAGE SQL STABLE STRICT
;
COMMENT ON FUNCTION userm_alog(int8, regclass, oid, tid, name)
 IS '    UPDATE  DELETE'
;
GRANT ALL ON type, ftp, grp, admin, client, cgroup, grpn, uidn, ftpn TO PUBLIC;
GRANT ALL ON "cipa log", "cipa&log&seq", "cipa&in&seq" TO PUBLIC;
